program main ( input , output ) ;
const
   a = 29 ; b = 7 ; c = 128;
   atimescminus1 = 3683;
type
   magicnumber = 0..32767;
   magicdomain = 0..127;
   magicvector = array [1..5] of magicnumber;

function findmagic ( x : magicdomain ; n : magicnumber ) : magicnumber ;
   var
      y : 0..atimescminus1;
   begin
      y := (x - b + c) mod c;
      while y mod a <> 0 do y := y + c;
      findmagic := y div a + n mod 256 * c
   end { findmagic };

function checkvalue ( magic : magicvector ) : magicnumber ;
   var
      m : magicnumber;
      i : 1..3;
   begin
      m := 0;
      for i := 1 to 3 do
         m := 32 * m + magic[i] div 16 mod 32;
      checkvalue := m
   end { checkvalue };

procedure newmagic ;
   var
      customer : magicnumber;
      answer : alfa;
      day : 1..31;
      month : 1..12;
      year : 1983..2082;
      magic : magicvector;
      i : 2..4;
   begin
      write('Customer number (0..32767): ');
      readln(customer);
      write('Do you wish to enable the system indefinitely? (Y/N): ');
      readln(answer);
      if answer[1] in ['Y','y'] then
      begin
         day := 31 ; month := 12 ; year := 2082
      end
      else
      begin
         writeln('Enter expiry date (other than 29th February)');
         write('Day (1..31): ');
         readln(day);
         write('Month (1..12): ');
         readln(month);
         if (month = 2) and (day > 28) or
            (month in [4,6,9,11]) and (day > 30)
         then halt('Error in date');
         write('Year (1983..2082): ');
         readln(year)
      end;
      magic[1] := findmagic(day,customer);
      magic[2] := findmagic(month,customer);
      magic[3] := findmagic(year-1983,customer);
      magic[4] := checkvalue(magic);
      magic[5] := customer;
      writeln;
      writeln('************************************************************');
      writeln;
      writeln('Customer number: ',customer:1);
      writeln;
      write('Expiry date: ',day:1);
      case day of
      1,21,31 : write('st ');
      2,22    : write('nd ');
      3,23    : write('rd ')
      otherwise write('th ')
      end;
      case month of
      1 : write('January');
      2 : write('February');
      3 : write('March');
      4 : write('April');
      5 : write('May');
      6 : write('June');
      7 : write('July');
      8 : write('August');
      9 : write('September');
      10: write('October');
      11: write('November');
      12: write('December')
      end;
      writeln(', ',year:4);
      writeln;
      write('New magic numbers are: ',magic[1]:1);
      for i := 2 to 4 do write(', ',magic[i]:1);
      writeln;
      writeln;
      writeln('************************************************************');
      writeln
   end { newmagic };

begin
   newmagic
end.
