{ Sheffield University Editor }
{ Copyright (c) University of Sheffield 1990 }

{*********************************************************}
{ DECLARATIONS FOR PROCEDURES IN THE EDITOR FILING SYSTEM }
{*********************************************************}

   procedure hook1(var vdu_type: integer); extern;  { enter editor }
   procedure hook2(vdu_type: integer); extern;      { leave editor }
   procedure hook3(vdu_type: integer); extern;      { enter window subsystem }
   procedure hook4(vdu_type: integer); extern;      { leave window subsystem }
   procedure hook5(old_vdu_type, new_vdu_type: integer); { change vdu type }
      extern;
   procedure hook6(vdu_type: integer); extern;      { reset string sent }
   procedure hook7(vdu_type, user_info: integer);   { user hook in vdu_control }
      extern;
   procedure hook8(var vdu_type: integer); extern;  { user chooses vdu_type }

{ LOW LEVEL PROCEDURES }

   procedure attach_home;
      extern;
   procedure call_srsfx$(key: shortint;
                         pathname: tree_string;
                         var unit, tipe, code: shortint);
      extern;
   procedure close_unit(the_unit: shortint; var code: shortint);
      extern;
   procedure close_file(var pfile: primos_file);
      extern;
   procedure open_file(key: integer;
                       var pfile: primos_file;
                       expected_size: integer;
                       allow_file, allow_buffer: boolean);
      extern;
   procedure close_paging_file(empty: boolean);
      extern;

{ HIGHER LEVEL ROUTINES }

   procedure replace_line;
      extern;
   procedure load_a_line(new_number: integer;
                         print: boolean);
      extern;
   procedure quick_locate(var string: line_chars_type;
                          var low_string: line_chars_type;
                          sstart, sstop: line_chars_range;
                          backwards: boolean;
                          case_signif: boolean;
                          print: boolean;
                          stop_line: integer);
      extern;
   procedure test_line_landed_on;
      extern;
   procedure save_place(var the_place: file_places);
      extern;
   procedure restore_place(the_place: file_places);
      extern;
   procedure insert_a_line;
      extern;
   procedure delete_line;
      extern;
   function load_a_file: boolean;
      extern;
   procedure oops_proc;
      extern;
   procedure announce_buffer_name;
      extern;
   procedure display_buffer_modified;
      extern;
   procedure init_buffer;
      extern;
   procedure empty_buffer;
      extern;
   procedure switch_buffer(new_buffer_number: buffer_range);
      extern;
   function find_next_chain_buffer(backwards, reposition: boolean): boolean;
      extern;
   procedure top_or_bottom_proc(backwards: boolean);
      extern;
   procedure list_buffers(show_size: boolean);
      extern;
   procedure find_next_used_buffer(forwards: boolean;
                                   var new_buffer_number: buffer_range);
      extern;
   function open_edit_file: boolean;
      extern;
   procedure set_edit_mode(newmode: boolean);
      extern;
   procedure quit_proc(is_qf_comm: boolean);
      extern;
   function save_proc(new_treename: tree_type; print_name: boolean): boolean;
      extern;
   procedure saveall_proc(at_logout: boolean);
      extern;
   function unload_line: boolean;
      extern;
   function quick_unload(start_line, stop_line: integer): boolean;
      extern;
   procedure quick_delete(start_line, stop_line: integer);
      extern;
   procedure strip_trailing_spaces;
      extern;
