program main ( input , output , infile , outfile ) ;
const
   magiclocation = 279 { 1st word in file is word number 1 - c.f. FILEPR };
   a = 29 ; b = 7 ; c = 128;
   atimescminus1 = 3683;
type
   filename = packed array [1..128] of char;
   magicnumber = 0..32767;
   magicdomain = 0..127;
   magicvector = array [1..5] of magicnumber;
var
   infile , outfile : packed file of 0..177777b;
   infn , outfn : filename;
   magic : magicvector;

function findmagic ( x : magicdomain ; n : magicnumber ) : magicnumber ;
   var
      y : 0..atimescminus1;
   begin
      y := (x - b + c) mod c;
      while y mod a <> 0 do y := y + c;
      findmagic := y div a + n mod 256 * c
   end { findmagic };

function checkvalue ( magic : magicvector ) : magicnumber ;
   var
      m : magicnumber;
      i : 1..3;
   begin
      m := 0;
      for i := 1 to 3 do
         m := 32 * m + magic[i] div 16 mod 32;
      checkvalue := m
   end { checkvalue };

procedure getmagic ( var magic : magicvector ) ;
   var
      customer : magicnumber;
      day : 1..31;
      month : 1..12;
      year : 1983..2082;
      answer : alfa;
   begin
      write('Customer number (0..32767): ');
      readln(customer);
      writeln('Enter expiry date (other than 29th February)');
      write('Day (1..31): ');
      readln(day);
      write('Month (1..12): ');
      readln(month);
      if (month = 2) and (day > 28) or
         (month in [4,6,9,11]) and (day > 30)
      then halt('Error in date');
      write('Year (1983..2082): ');
      readln(year);
      writeln;
      writeln('Customer number: ',customer:1);
      writeln;
      write('Expiry date: ',day:1);
      case day of
      1,21,31 : write('st ');
      2,22    : write('nd ');
      3,23    : write('rd ')
      otherwise write('th ')
      end;
      case month of
      1 : write('January');
      2 : write('February');
      3 : write('March');
      4 : write('April');
      5 : write('May');
      6 : write('June');
      7 : write('July');
      8 : write('August');
      9 : write('September');
      10: write('October');
      11: write('November');
      12: write('December')
      end;
      writeln(', ',year:4);
      writeln;
      write('OK to continue? (Y/N): ');
      readln(answer);
      if not (answer[1] in ['Y','y'])
      then halt('Program aborted');
      magic[1] := findmagic(day,customer);
      magic[2] := findmagic(month,customer);
      magic[3] := findmagic(year-1983,customer);
      magic[4] := checkvalue(magic);
      magic[5] := customer
   end { getmagic };

procedure setmagic ( infn , outfn : filename ; newmagic : magicvector ) ;
   var
      oldmagic : magicvector;
      stillvalid : boolean;
      i : integer;
      j : 1..5;
   begin
      reset(infile,infn);
      rewrite(outfile,outfn);
      for i := 1 to magiclocation - 1 do
      begin
         outfile^ := infile^;
         put(outfile);
         get(infile)
      end;
      for j := 1 to 5 do read(infile,oldmagic[j]);
      stillvalid := true;
      for j := 1 to 3 do
         if oldmagic[j] div 128 <> oldmagic[5] mod 256
         then stillvalid := false;
      if not stillvalid or (oldmagic[4] <> checkvalue(oldmagic)) then
      begin
         writeln('The input file contains invalid data.');
         halt('Invalid data')
      end;
      for j := 1 to 5 do write(outfile,newmagic[j]);
      while not eof(infile) do
      begin
         outfile^ := infile^;
         put(outfile);
         get(infile)
      end
   end { setmagic };

begin
   write('Library input pathname: ');
   readln(infn);
   write('Library output pathname: ');
   readln(outfn);
   getmagic(magic);
   setmagic(infn,outfn,magic)
end.
