program main ( input , output ) ;
const
   magiclocation = 279 { 1st word in file is word number 1 - c.f. FILEPR };
   a = 29 ; b = 7 ; c = 128;
   atimescminus1 = 3683;

%insert syscom>keys.ins.pas

type
   char16 = packed array[1..16] of char;
   magicnumber = 0..32767;
   magicdomain = 0..127;
   magicvector = array [1..5] of magicnumber;
   dtmvector = array [1..2] of shortint;
var
   newmagic : magicvector;

procedure getdtm (filename: char16; var dtm: dtmvector; var worked: boolean);
   type
      buffertype = array [1..24] of shortint;
   var
      funit , ftype , code , rnw : shortint;
      buffer : buffertype;

   procedure srch$$ ( keys , filnam , namlen : shortint ;
                      var funit , ftype , code : shortint ) ; extern ;

   procedure rden$$ ( key , funit : shortint ;
                      var buffer : buffertype ; buflen : shortint ;
                      var rnw : shortint ;
                      filnam : char16 ; namlen : shortint ;
                      var code : shortint ) ; extern ;

   begin
      worked := false;
      srch$$(k$read+k$getu,k$curr,0,funit,ftype,code);
      if (code = 0) and (ftype = 4) then
      begin
         rden$$(k$name,funit,buffer,24,rnw,filename,16,code);
         if (code = 0) and (rnw = 24) then
         begin
            worked := true;
            dtm[1] := buffer[21] ; dtm[2] := buffer[22]
         end
      end;
      srch$$(k$clos,0,0,funit,ftype,code)
   end { getdtm };

procedure resetdtm (filename: char16; dtm: dtmvector);
   var
      code : shortint;

   procedure satr$$ ( key : shortint ;
                      filnam : char16 ; namelen : shortint ;
                      dtm : dtmvector ; var code : shortint ) ; extern ;

   begin
      satr$$(k$dtim,filename,16,dtm,code)
   end { resetdtm };

function consistent ( magic : magicvector ) : boolean ;
   var
      stillconsistent : boolean;
      i : 1..3;

   function checkvalue ( magic : magicvector ) : magicnumber ;
      var
         m : magicnumber;
         i : 1..3;
      begin
         m := 0;
         for i := 1 to 3 do
            m := 32 * m + magic[i] div 16 mod 32;
         checkvalue := m
      end { checkvalue };

   begin { consistent }
      stillconsistent := true;
      for i := 1 to 3 do
         if magic[i] div 128 <> magic[5] mod 256
         then stillconsistent := false;
      consistent := stillconsistent and (magic[4] = checkvalue(magic))
   end { consistent };

procedure getmagic (filename: char16; var magic : magicvector);

   var
      customer , n : magicnumber;
      libfile : packed file of 0..177777b;
      i : 1..4;
      answer : char16;
   begin
      write('Identifier: ');
      customer := 0;
      if input^ in ['C','c'] then
      begin
         get(input);
         if input^ in ['0'..'9']
         then read(customer)
      end;
      readln;
      open(libfile, filename);
      seek(libfile,magiclocation+4);
      get(libfile) ; n := libfile^;
      close(libfile);
      if customer <> n
      then halt('Identifier not found');
      magic[5] := customer;
      writeln('Type in numbers supplied by distributor...');
      for i := 1 to 4 do
      begin
         write(i:1,': ');
         readln(magic[i])
      end;
      writeln;
      write('Numbers are: ',magic[1]:1);
      for i := 2 to 4 do write(', ',magic[i]:1);
      writeln;
      writeln;
      write('OK to continue? (Y/N): ');
      readln(answer);
      if not (answer[1] in ['Y','y'])
      then halt('Program aborted');
      if not consistent(magic) then
      begin
         writeln('These numbers are inconsistent - contact your distributor.');
         halt('Inconsistent input')
      end
   end { getmagic };

procedure changemagic ( libname : char16 ; newmagic : magicvector ) ;
   var
      libfile : packed file of 0..177777b;
      oldmagic : magicvector;
      worked, stillvalid : boolean;
      i : 1..5;
      dtm: dtmvector;
   begin
      getdtm(libname, dtm, worked);
      open(libfile,libname);
      seek(libfile,magiclocation);
      get(libfile);
      for i := 1 to 5 do read(libfile,oldmagic[i]);
      if not consistent(oldmagic) then
      begin
         writeln('System contains invalid data - contact your distributor.');
         halt('Invalid data')
      end;
      seek(libfile,magiclocation);
      for i := 1 to 4 do write(libfile,newmagic[i]);
      close(libfile);
      if worked
      then resetdtm(libname, dtm)
   end { changemagic };

begin
   getmagic   ('PMED_BITS.BIN   ',newmagic);
   changemagic('PMED_BITS.BIN   ',newmagic)
end.
