program RLBPRINT(input, output);

var
   rlbfile: packed file of 0..65535;
   outfile: text;
   blocksize, blockstart, groupsize, groupstart, groupheader, wordsleft, index: integer;
   filename: string;

begin
   write('RLB filename: ');
   readln(filename);
   reset(rlbfile, filename);
   write('Output file: ');
   readln(filename);
   rewrite(outfile, filename);
   blockstart := 0;
   while not eof(rlbfile) do
   begin
      read(rlbfile, blocksize);
      writeln(outfile,'block ',blockstart:8,blocksize:8);
      if blocksize > 0
      then get(rlbfile);
      wordsleft := blocksize - 1;
      groupstart := blockstart + 2;
      while wordsleft > 0 do
      begin
         read(rlbfile, groupheader);
         groupsize := groupheader mod 256;
         writeln(outfile,'      ',groupstart:8,groupsize:8);
         if groupsize > wordsleft then
         begin
            writeln(blockstart:1,' ',groupheader div 256,' ',groupsize);
            halt('ER')
         end;
         groupstart := groupstart + groupsize + 1;
         for index := 1 to groupsize
         do get(rlbfile);
         wordsleft := wordsleft - groupsize - 1
      end;
      blockstart := blockstart + blocksize + 1
   end
end.
