   function file_exists(filename: tree_string): boolean;
      extern;
   function get_c1in: char;
      extern;
   procedure read_cominput_line(var the_string_buffer: edline_type);
      extern;
   procedure stop_cominput;
      extern;
   procedure error_print(key, code: shortint;
                         error_text: long_string;
                         name: string32);
      extern;
   procedure abort(message: string);
      extern;
   function cominput_open: boolean;
      extern;
   function free_dynamic_segments: integer;
      extern;
   procedure ctrl_term(cont: cont_type; switch_on: boolean);
      extern;
   procedure ctrl_half_duplex(switch_on: boolean);
      extern;
   procedure trim_string(var the_string: long_string);
      extern;
   procedure upcase_string(var the_string: long_string);
      extern;
   procedure calculate_window_sizes;
      extern;
   procedure comm_error(message: string);
      extern;
   function compare(word1, word2: word): boolean;
      extern;
   procedure write_tree(var pfile: primos_file);
      extern;
   function tree_to_dec(in_tree: tree_type; var valu: integer): boolean;
      extern;
   procedure wrt_ch_octal(ch: char);
      extern;
   procedure wrt_ch_mode(ch: char);
      extern;
   procedure print_line;
      extern;
   procedure verify_print;
      extern;
   procedure find_indent(var indent_col: line_chars_range;
                         highest_allowed: integer);
      extern;
   procedure banner(banner_indent: integer);
      extern;
   procedure update_changed_lines(ln: integer);
      extern;
   function string_to_integer(the_string: string;
                              var the_integer: integer): boolean;
      extern;
   procedure set_up_sets;
      extern;
   procedure get_erase_and_kill;
      extern;
   procedure change_to_input_mode;
      extern;
   procedure test_init_eof(force_eof: boolean);
      extern;
   procedure set_global(name: string;
                        valu: string;
                        var code: shortint);
      extern;
   procedure get_term_gv;
      extern;
   procedure set_term_gv;
      extern;
   procedure decide_vdu_type;
      extern;
   procedure message_and_reply(message: long_string;
                               highlight_it: boolean;
                               var answer: long_string;
                               var cr_given: boolean);
      extern;
   function question_and_answer(message: long_string;
                                highlight_it: boolean;
                                default_value: boolean): boolean;
      extern;
   procedure text_format(old_left_margin: integer;
                         function get_from_line(
                            var from_line: line_chars_type;
                            var from_length: line_chars0_range): boolean;
                         procedure write_to_line(
                            to_line: line_chars_type;
                            to_length: line_chars0_range) );
      extern;
   procedure free_mbufs(var ptr: ptr_macro_buffer);
      extern;
   procedure free_macro(var ptr: ptr_macro_desc);
      extern;
   procedure new_macro_buffer(var ptr: ptr_macro_buffer);
      extern;
   procedure store_macro_code(the_code: integer);
      extern;
   procedure help_system(first_key: long_string);
      extern;
   procedure spell_proc(procedure show_line;
                        procedure ask_user(msg: string; var answer_char: char);
                        procedure show_changed_line);
      extern;
   procedure write_ld_file(var ld_filename: long_string);
      extern;
   procedure delete_primos_file(the_filename: long_string);
      extern;
   procedure expand_abbrevs(var the_treename: tree_type);
      extern;
   procedure trim(var the_string: tree_string);
      extern;
   procedure split_at_chars(source, splitter: tree_string;
                            var before, after: tree_string);
      extern;
   procedure split_at_space(source: tree_string; var before, after: tree_string);
      extern;
   procedure expand_pathname(original_pathname: tree_string;
                             var any_expansion: boolean;
                             procedure deliver(expanded_pathname: tree_string;
                                               var continue_expanding: boolean));
      extern;
